# sud.py
import g,random,utils,os,buttons,pygame

squares=[] # 9x9
piles=[0,0,0,0,0,0,0,0,0,0] # piles[1..9]= number of tiles left in pile 1..9
layout=[None,None,None,None,None,None]
layout[0]= [6,0,0,1,0,8,2,0,3,0,2,0,0,4,0,0,9,0,8,0,3,0,0,5,4,0,0,\
            5,0,4,6,0,7,0,0,9,0,3,0,0,0,0,0,5,0,7,0,0,8,0,3,1,0,2,\
            0,0,1,7,0,0,9,0,6,0,8,0,0,3,0,0,2,0,3,0,2,9,0,4,0,0,5]
layout[1]= [9,7,0,3,0,4,0,6,5,0,2,0,5,0,6,0,8,0,0,0,0,0,0,0,0,0,0,\
            0,0,5,8,0,2,9,0,0,0,0,2,0,4,0,3,0,0,0,0,8,7,0,5,1,0,0,\
            0,0,0,0,0,0,0,0,0,0,6,0,2,0,8,0,3,0,8,4,0,1,0,9,0,2,7]
layout[2]= [0,0,1,0,0,0,6,0,0,0,5,0,0,3,0,0,7,0,9,0,0,1,0,6,0,0,4,\
            0,0,2,0,7,0,8,0,0,0,7,0,4,0,3,0,9,0,0,0,4,0,1,0,2,0,0,\
            5,0,0,7,0,9,0,0,2,0,1,0,0,6,0,0,3,0,0,0,9,0,0,0,5,0,0]
layout[3]= [0,9,8,5,0,0,2,0,0,1,0,0,0,0,0,0,0,4,0,5,0,0,0,0,0,3,0,\
            0,0,2,6,4,3,1,0,0,0,0,0,9,0,8,0,0,0,0,0,7,1,5,2,6,0,0,\
            0,7,0,0,0,0,0,8,0,2,0,0,0,0,0,0,0,7,0,0,6,0,0,1,5,2,0]
layout[4]= [3,0,2,0,7,0,5,0,4,0,0,0,0,0,0,0,0,0,0,0,6,2,5,4,0,0,0,\
            0,9,0,0,0,0,6,0,0,0,0,8,9,6,5,1,0,0,0,0,5,0,0,0,0,2,0,\
            0,0,0,1,9,7,8,0,0,0,0,0,0,0,0,0,0,0,5,0,7,0,8,0,2,0,6]
layout[5]= [0,0,0,0,4,1,0,0,0,0,6,0,0,0,0,2,0,0,0,0,0,0,0,0,0,0,0,\
            3,2,0,6,0,0,0,0,0,0,0,0,0,5,0,0,4,1,7,0,0,0,0,0,0,0,0,\
            0,0,0,2,0,0,3,0,0,0,4,8,0,0,0,0,0,0,5,0,1,0,0,0,0,0,0]


class Square:
    def __init__(self,sqr,r,c,x,y): # sq,r,c all 0..8
        self.sqr=sqr; self.r=r; self.c=c; self.x=x; self.y=y
        self.ind=len(squares)
        self.given=False
        self.piece=0 # 0..9 (0=empty)
        self.wrong=False

class Board:
    def __init__(self):
        d=g.d+g.space
        y=g.y0; sqr0=0
        for r in range(9): # 0..8
            x=g.x0; sqr=sqr0
            for c in range(9): # 0..8
                sq=Square(sqr,r,c,x,y)
                squares.append(sq)
                x+=d
                if c in (2,5): sqr+=1
            y+=d
            if r in (2,5): sqr0+=3
        self.layout_n=0
        if g.count>0: self.layout_n=random.randint(1,3)
        self.d=d; self.mouse_offset=int(.8*d)

    def setup(self):
        for i in range(1,10): piles[i]=9 # 1..9
        ind=0
        for piece in layout[self.layout_n]:
            squares[ind].piece=0; squares[ind].given=False
            squares[ind].wrong=False
            if piece>0:
                squares[ind].piece=piece; squares[ind].given=True
                piles[piece]-=1
            ind+=1
        self.clear()
        self.shuffle()
        if g.count>0: self.layout_n+=1
        if self.layout_n==len(layout):
            self.layout_n=1 # don't do extra easy one again

    def reset(self):
        if self.carry>0: piles[self.carry]+=1 
        for sq in squares:
            if sq.piece>0 and not sq.given:
                piles[sq.piece]+=1; sq.piece=0; sq.wrong=False
        self.clear()

    def clear(self):
        self.carry=0; self.clashes=[]; g.finished=False; g.glow_sq=None
        g.helped=0 # don't count if helped>5

    def draw(self):
        # grid
        d=g.sy(.16)
        x=squares[0].x-d; y=squares[0].y-d
        g.screen.blit(g.grid,(x,y))
        for sq in squares:
            x=sq.x; y=sq.y
            if sq.piece>0:
                tile=g.cream
                if sq.given: tile=g.cyan
                g.screen.blit(tile,(sq.x,sq.y))
                g.screen.blit(g.pics[sq.piece],(sq.x,sq.y))
        # piles
        x=squares[0].x-d; y=squares[0].y-d
        g.screen.blit(g.grid1,(x,y))
        y=squares[0].y; dx=g.sy(.8); dy=g.d+g.space
        for r in range(9): # 0..8
            piece=r+1; x=g.sx(.2)
            for i in range(piles[piece]):
                g.screen.blit(g.cream,(x,y))
                g.screen.blit(g.pics[piece],(x,y)); x+=dx
            if g.green_on and not g.finished:
                utils.display_number1(r+1,(x+self.d-dx,y+dy/2),g.font1,utils.CREAM)
            y+=dy
        # selector square
        if g.green_on:
            sq=squares[g.green]; x=sq.x; y=sq.y; s=self.d
            pygame.draw.rect(g.screen,utils.ORANGE,(x,y,s,s),g.green_w)
        # clashes
        for sq in self.clashes: g.screen.blit(g.cross,(sq.x,sq.y))
        # glow (from help)
        if g.glow_sq<>None:
            x=g.glow_sq.x-g.glow_d; y=g.glow_sq.y-g.glow_d
            g.screen.blit(g.glow,(x,y))
        # carry tile
        if self.carry:
            mx,my=g.pos
            utils.centre_blit(g.screen,g.shadow,(mx,my))
            utils.centre_blit(g.screen,g.cream,(mx,my))
            utils.centre_blit(g.screen,g.pics[self.carry],(mx,my))
            
    def click(self):
        g.glow_sq=None
        if self.carry==0:
            n=self.which_pile()
            if n>0:
                piles[n]-=1; self.carry=n; g.green_on=False
            else:
                sq=self.which_square()
                if sq<>None:
                    if not sq.given:
                        if sq<>None:
                            self.carry=sq.piece; sq.piece=0; sq.wrong=False
        else:
            sq=self.which_square()
            if sq==None:
                piles[self.carry]+=1; self.carry=0
            else:
                if self.place(sq,self.carry): self.carry=0
        self.check() # check for clashes

    def mouse_set(self):
        if g.green<>None:
            sq=squares[g.green]
            t=self.mouse_offset; x=sq.x+t; y=sq.y+t
            pygame.mouse.set_pos(x,y); g.pos=(x,y)
            g.green_on=True
            if self.carry>0: piles[self.carry]+=1; self.carry=0
        
    def key(self,n):
        if not g.green_on: return 
        if n>0 and piles[n]==0: return
        if self.carry>0:
            piles[self.carry]+=1; self.carry=0; self.mouse_set(); return
        g.glow_sq=None
        sq=squares[g.green]
        if n==0:
            if sq.given: return
            if sq.piece>0: piles[sq.piece]+=1; sq.piece=0; sq.wrong=False
        elif self.place(sq,n):
            piles[n]-=1
        self.check() # check for clashes

    def place(self,sq,piece): # if possible
        if sq.given: return False
        sq.wrong=False
        if sq.piece>0: piles[sq.piece]+=1; sq.piece=0 # put piece back
        if self.clash(sq,piece): sq.wrong=True
        elif self.multiple(sq,piece): sq.wrong=True
        sq.piece=piece # place piece - rely on caller to adjust pile
        buttons.on('reset')
        return True
        
    def clash(self,sq,piece):
        # row clash?
        ind=sq.r*9
        for c in range(9):
            if not squares[ind].wrong:
                if squares[ind].piece==piece: return True
            ind+=1
        # col clash?
        ind=sq.c
        for r in range(9):
            if not squares[ind].wrong:
                if squares[ind].piece==piece: return True
            ind+=9
        # sq clash?
        ind=top_left_ind(sq)
        for r in range(3):
            for c in range(3):
                if not squares[ind].wrong:
                    if squares[ind].piece==piece: return True
                ind+=1
            ind+=6
        return False           
        
    def multiple(self,sq,piece):
        # given: piece can go on sq without clash
        # is this a forced move?
        # row check
        ind=sq.r*9; found=False
        for c in range(9):
            if sq.ind!=ind:
                sq1=squares[ind]
                if sq1.piece==0 or sq1.wrong:
                    if not self.clash(sq1,piece): found=True; break
            ind+=1
        if not found: return False # ie row force
        # col check
        ind=sq.c; found=False
        for r in range(9):
            if sq.ind!=ind:
                sq1=squares[ind]
                if sq1.piece==0 or sq1.wrong:
                    if not self.clash(sq1,piece): found=True; break
            ind+=9
        if not found: return False # ie col force
        # sq check
        ind=top_left_ind(sq); found=False
        for r in range(3):
            for c in range(3):
                if sq.ind!=ind:
                    sq1=squares[ind]
                    if sq1.piece==0 or sq1.wrong:
                        if not self.clash(sq1,piece): found=True; break
                ind+=1
            if found: break
            ind+=6
        if not found: return False # ie square force
        return True           
        
    def which_pile(self):
        y=squares[0].y; dx=g.sy(.8); dy=g.d+g.space
        for r in range(1,10): # 1..9
            x=g.sx(.2)
            for i in range(1,piles[r]+1):
                if i==piles[r]:
                    if utils.mouse_in(x,y,x+g.d,y+g.d): return r
                x+=dx
            y+=dy
        return 0
    
    def which_square(self):
        for sq in squares:
            if utils.mouse_in(sq.x,sq.y,sq.x+g.d,sq.y+g.d): return sq
        return None
        
    def green_move(self):
        sq=self.which_square()
        if sq!=None: g.green=sq.ind
            
    def check(self): # generates list of clashing squares
        clashes=[]
        # rows
        for r in range(9): # 0..8
            for piece in range(1,10): # 1..9
                sqs=[]
                for sq in squares:
                    if sq.r==r:
                        if sq.piece==piece: sqs.append(sq)
                if len(sqs)>1:
                    for sq in sqs:
                        if sq not in clashes: clashes.append(sq)
        #columns
        for c in range(9): # 0..8
            for piece in range(1,10): # 1..9
                sqs=[]
                for sq in squares:
                    if sq.c==c:
                        if sq.piece==piece: sqs.append(sq)
                if len(sqs)>1:
                    for sq in sqs:
                        if sq not in clashes: clashes.append(sq)
        #squares
        for sqr in range(9): # 0..8
            for piece in range(1,10): # 1..9
                sqs=[]
                for sq in squares:
                    if sq.sqr==sqr:
                        if sq.piece==piece: sqs.append(sq)
                if len(sqs)>1:
                    for sq in sqs:
                        if sq not in clashes: clashes.append(sq)
        self.clashes=clashes
        if len(clashes)==0: self.complete() # check if complete

    def complete(self):
        if g.finished:
            return True
        else:
            if self.carry>0: return False # make sure last piece put down !
            for i in range(1,10): # 1..9
                if piles[i]>0: return False
            g.finished=True
            g.glow_sq=None
            if g.helped<6: g.count+=1
            return True
        
    def row_swap(self,r1,r2):
        ind1=r1*9; ind2=r2*9
        for i in range(9): # 0..8
            sq1=squares[ind1]; sq2=squares[ind2]
            sq1.given,sq2.given=sq2.given,sq1.given
            sq1.piece,sq2.piece=sq2.piece,sq1.piece
            ind1+=1; ind2+=1
        
    def col_swap(self,c1,c2):
        ind1=c1; ind2=c2
        for i in range(9): # 0..8
            sq1=squares[ind1]; sq2=squares[ind2]
            sq1.given,sq2.given=sq2.given,sq1.given
            sq1.piece,sq2.piece=sq2.piece,sq1.piece
            ind1+=9; ind2+=9
        
    def shuffle(self): # shuffle the current layout
        for i in range(5):
            # row swap
            r1=random.randint(0,2); r2=random.randint(0,2)
            d=random.randint(0,2)*3
            self.row_swap(r1+d,r2+d)
            # col swap
            c1=random.randint(0,2); c2=random.randint(0,2)
            d=random.randint(0,2)*3
            self.col_swap(c1+d,c2+d)
            # hor squares swap
            r1=random.randint(0,2)*3; r2=random.randint(0,2)*3
            for d in range(3): self.row_swap(r1+d,r2+d)
            # ver squares swap
            c1=random.randint(0,2)*3; c2=random.randint(0,2)*3
            for d in range(3): self.col_swap(c1+d,c2+d)

    def find_move(self): # help
        self.clashes=[]
        for sq in squares: # remove wrong squares
            if sq.wrong:
                n=sq.piece; piles[n]+=1; sq.piece=0; sq.wrong=False
        for sq in squares:
            if sq.piece==0:
                for n in range(1,10): # 1..9
                    if piles[n]>0:
                        if not self.clash(sq,n):
                            if not self.multiple(sq,n):
                                self.place(sq,n); piles[n]-=1
                                g.helped+=1; g.glow_sq=sq
                                return

    def solve(self): # for testing
        while not g.finished:
            self.find_move()
            self.complete()

    def fill(self): # for testing - use straight after setup()
        pce=1
        for sq in squares:
            if not sq.given:
                if piles[pce]==0: pce+=1
                self.place(sq,pce)
                piles[pce]-=1
        self.check()

def top_left_ind(sq):
    for r in (6,3,0):
        if sq.r>=r: break
    for c in (6,3,0):
        if sq.c>=c: break
    return r*9+c # return ind
        
                    


